<template>
  <div class="h-100 min-h-screen bg-gray-900">
    <swole-header></swole-header>
    <div
      class="flex flex-col items-start items-center justify-center w-full w-full p-2 px-4 lg:p-12"
    >
      <div
        class="px-6 text-white text-center rounded-lg border border-gray-300 mb-10 w-11/12 py-2 lg:w-4/5 lg:py-16"
      >
        <h1 class="font-bold text-2xl lg:py-8 py-2">
          Fuck yeah, you are {{ level.desc }}
        </h1>
        <h2 class="font-bold text-2xl lg:py-8 py-2">You smashed it in {{ time }} mins</h2>
        <div class="flex flex-col">
          <div class="-my-2 overflow-x-auto sm:-mx-6 lg:-mx-8">
            <div class="py-2 align-middle inline-block min-w-full sm:px-6 lg:px-8">
              <div class="shadow overflow-hidden border-b border-gray-200 sm:rounded-lg">
                <table class="min-w-full divide-y divide-gray-200 text-gray-300">
                  <thead class="">
                    <tr>
                      <th
                        scope="col"
                        class="px-6 py-3 text-left text-xs font-medium uppercase tracking-wider"
                      >
                        Exercise
                      </th>
                      <th
                        scope="col"
                        class="px-6 py-3 text-left text-xs font-medium uppercase tracking-wider"
                      >
                        Sets
                      </th>
                    </tr>
                  </thead>
                  <tbody>
                    <tr v-for="exercise in exercises" :key="exercise.name">
                      <td class="px-6 py-4 whitespace-nowrap text-sm font-medium">
                        {{ exercise.name }}
                      </td>
                      <td class="px-6 py-4 whitespace-nowrap text-sm">
                        x{{ level.sets }}
                      </td>
                    </tr>
                  </tbody>
                </table>
              </div>
            </div>
          </div>
        </div>
        <div class="w-100 border-b border-gray-100" />
        <button
          v-if="!connected"
          @click="handleLogin"
          class="uppercase border border-gray-100 text-center text-sm mt-10 px-12 py-2 rounded-md font-bold bg-primary-very-light text-primary-blue"
        >
          Connect to Google
        </button>
        <button
          v-if="connected"
          @click="sendToGoogleFit"
          class="uppercase border border-gray-100 text-center text-sm mt-10 px-12 py-2 rounded-md font-bold bg-primary-very-light text-primary-blue"
        >
          Send to Google
        </button>
        <button
          @click="restart"
          class="uppercase border border-gray-100 text-center text-sm mt-10 px-12 py-2 rounded-md font-bold bg-primary-very-light text-primary-blue"
        >
          Start Again
        </button>
      </div>
    </div>
  </div>
</template>

<script>
import SwoleHeader from "@/components/SwoleHeader.vue";
import { setLoading, setModalMessage } from "@/services/modal";
import { useRouter } from "vue-router";
import { useExercise, useGoogle, useGoogleFit } from "@/hooks";
import { millisToMinutes } from "@/utils";

export default {
  name: "Finish",
  components: {
    SwoleHeader,
  },
  setup() {
    const router = useRouter();
    const { reset, levels, exercises, timing, current } = useExercise();
    const { login, accessToken, googleEmail: connected, disconnect } = useGoogle();
    const { sendIt } = useGoogleFit();

    const level = levels[current.level - 1];
    const time = millisToMinutes({ time: timing.time });

    const sendToGoogleFit = async () => {
      setLoading();
      try {
        const googleResponse = await sendIt({
          access_token: accessToken.value,
          start: timing.start,
          finish: timing.finish,
          title: `Big 3: ${level.desc}`,
        });

        if(googleResponse){
          setModalMessage({
              title: 'Google Fit Data added',
              open: true
          });
          await disconnect();

        }

      } catch (error){
        setModalMessage({
            title: 'Google Fit error',
            open: true
        });
      }
      setLoading({ open: false });
    }
    
    const handleLogin = async () => {
      setLoading();
      try{
        await login();
      } catch (error){
        setModalMessage({
          title: 'Google login error',
          message: JSON.stringify(error),
          open: true
        });
      }
      setLoading({ open: false });
    }

    const restart = () => {
      reset();
      router.push("/");
    }

    return {
      level,
      time,
      timing,
      connected,
      exercises,
      restart,
      handleLogin,
      sendToGoogleFit,
    };
  },
};
</script>
